#include <cpu_prog_model.h>
#include <cpu6502_addrm.h>



void LDA_imm( code)
PM *code;
{
   code->Ac = code->Me [imm_address( code)];
   set_neg_zero_stat( code, code->Ac);
}

void LDA_zer( code)
PM *code;
{
   unsigned short int address;

   address = zero_address( code);
   mem_check( address, &(code->Me [address]), code, Func_LOAD);
   code->Ac = code->Me [address];
   set_neg_zero_stat( code, code->Ac);
}

void LDA_zex( code)
PM *code;
{
   unsigned short int address;

   address = zero_x_address( code);

   mem_check( address, &(code->Me [address]), code, Func_LOAD);
   code->Ac = code->Me [address];
   set_neg_zero_stat( code, code->Ac);
}

void LDA_abs( code)
PM *code;
{
   unsigned short int address;

   address = abs_address( code);

   mem_check( address, &(code->Me [address]), code, Func_LOAD);
   code->Ac = code->Me [address];

   set_neg_zero_stat( code, code->Ac);
}

void LDA_abx( code)
PM *code;
{
   unsigned short int address;

   address = abs_x_address( code);

   mem_check( address, &(code->Me [address]), code, Func_LOAD);
   code->Ac = code->Me [address];
   set_neg_zero_stat( code, code->Ac);
}

void LDA_aby( code)
PM *code;
{
   unsigned short int address;

   address = abs_y_address( code);

   mem_check( address, &(code->Me [address]), code, Func_LOAD);
   code->Ac = code->Me [address];
   set_neg_zero_stat( code, code->Ac);
}

void LDA_inx( code)
PM *code;
{
   unsigned short int address;

   address = ind_x_address( code);

   mem_check( address, &(code->Me [address]), code, Func_LOAD);
   code->Ac = code->Me [address];
   set_neg_zero_stat( code, code->Ac);
}

void LDA_iny( code)
PM *code;
{
   unsigned short int address;

   address = ind_y_address( code);
   mem_check( address, &(code->Me [address]), code, Func_LOAD);
   code->Ac = code->Me [address];
   set_neg_zero_stat( code, code->Ac);
}


void LDX_imm( code)
PM *code;
{
   code->Xr = code->Me [imm_address( code)];
   set_neg_zero_stat( code, code->Xr);
}

void LDX_zer( code)
PM *code;
{
   unsigned short int address;

   address = zero_address( code);
   mem_check( address, &(code->Me [address]), code, Func_LOAD);
   code->Xr = code->Me [address];
   set_neg_zero_stat( code, code->Xr);
}

void LDX_zex( code)
PM *code;
{
   unsigned short int address;

   address = zero_x_address( code);
   mem_check( address, &(code->Me [address]), code, Func_LOAD);
   code->Xr = code->Me [address];
   set_neg_zero_stat( code, code->Xr);
}

void LDX_abs( code)
PM *code;
{
   unsigned short int address;

   address = abs_address( code);
   mem_check( address, &(code->Me [address]), code, Func_LOAD);
   code->Xr = code->Me [address];
   set_neg_zero_stat( code, code->Xr);
}

void LDX_abx( code)
PM *code;
{
   unsigned short int address;

   address = abs_x_address( code);
   mem_check( address, &(code->Me [address]), code, Func_LOAD);
   code->Xr = code->Me [address];
   set_neg_zero_stat( code, code->Xr);
}

void LDX_aby( code)
PM *code;
{
   unsigned short int address;

   address = abs_y_address( code);
   mem_check( address, &(code->Me [address]), code, Func_LOAD);
   code->Xr = code->Me [address];
   set_neg_zero_stat( code, code->Xr);
}


void LDY_imm( code)
PM *code;
{
   code->Yr= code->Me [imm_address( code)];
   set_neg_zero_stat( code, code->Yr);
}

void LDY_zer( code)
PM *code;
{
   unsigned short int address;

   address = zero_address( code);
   mem_check( address, &(code->Me [address]), code, Func_LOAD);
   code->Yr = code->Me [address];
   set_neg_zero_stat( code, code->Yr);
}

void LDY_zex( code)
PM *code;
{
   unsigned short int address;

   address = zero_x_address( code);
   mem_check( address, &(code->Me [address]), code, Func_LOAD);
   code->Yr = code->Me [address];
   set_neg_zero_stat( code, code->Yr);
}

void LDY_abs( code)
PM *code;
{
   unsigned short int address;

   address = abs_address( code);

   mem_check( address, &(code->Me [address]), code, Func_LOAD);
   code->Yr = code->Me [address];
   set_neg_zero_stat( code, code->Yr);

}

void LDY_abx( code)
PM *code;
{
   unsigned short int address;

   address = abs_x_address( code);

   mem_check( address, &(code->Me [address]), code, Func_LOAD);
   code->Yr = code->Me [address];
   set_neg_zero_stat( code, code->Yr);

}

