#define APPLE_PROGS    "cpu>medlem>torbjorn>c>apple>apple_progs"


typedef struct
{
   short Ac,     /* Accumulator       */
         Xr,     /* Index_X           */
         Yr,     /* Index_Y           */
         SP;     /* Stack_Pointer     */

                 /* Program_Counter   */
   unsigned short int PC;

         /* Processor_Status flags */
   short Ca,     /* Carry             */
         Ze,     /* Zero              */
         In,     /* Interrupt         */
         De,     /* Decimal           */
         Br,     /* Break commad      */
         Ov,     /* Overflow          */
         Ne;     /* Negative          */

   short Er,     /* Error status      */
         Qu,     /* Quit request      */
         Tr,     /* Trace mode        */
         Tl,     /* Trace level (JSR) */
         Mo,     /* Mode (FAST/SLOW)  */
         Ex,     /* Exit Complit exit */
         Sl;     /* Working slot      */

                 /* Start_pointer     */
   unsigned short int   St;

                 /* Memory            */
   unsigned short int * Me;

} PM;            /* Programming_Model */

/* Define mode */
#define Mode_SLOW    0
#define Mode_FAST    1

/* Define Type of memcheck */
#define Func_TEST    0
#define Func_JSR     1
#define Func_JMP     2
#define Func_LOAD    3
#define Func_STORE   4

/* Define mnen types */
#define NONE         0
#define Implied      1
#define Immediate    2
#define Zero_page    3
#define Zero_page_X  4
#define Zero_page_Y  5
#define Absolute     6
#define Absolute_X   7
#define Absolute_Y   8
#define Indirect_X   9
#define Indirect_Y  10
#define Indirect    11
#define Relative    12
#define Accumulator 13

/* Define type of Real_time */
#define HOUR         0
#define MINUTE       1
#define SECOND       2


#define _READ   0
#define _WRITE  1
#define _MODIFY 2
#define _OPEN   3
#define _CLOSE  4


